module MySQLNoIo
  module Wraps
    # Just an example Wrap for testing and examples.
    class Blocks
      # The before block will be run prior to the execution.
      def before &block
        @prior = block
      end

      # The after block will be run post execution.
      def after &block
        @post = block
      end

      # Call the prior block, then execute, and then call the post-block.
      def execute &block
        @prior.call if @prior.respond_to?(:call)
        block.call
      ensure
        @post.call if @post.respond_to?(:call)
      end
    end
  end
end
