module MySQLNoIo
  module Wraps
    # Allows you to run commands against a MySQL database, while MySQL's
    # tables are locked, and the tables are flushed.
    class GlobalLock
      # Prepare to set up the GlobalLock wrapper, with the mysql2 connection
      def initialize mysql
        @mysql = mysql
      end

      # Lock the tables, run our command, and then unlock the tables.
      def execute &block
        @mysql.query("FLUSH TABLES WITH READ LOCK;")
        yield
      ensure
        @mysql.query("UNLOCK TABLES;")
      end
    end
  end
end

